plot.bayesIV=function(object,covariate=NULL,equation=NULL,center=T,PLOT=T,ask=dev.interactive(),xlab=NULL,ylab=NULL,ylim=NULL,main=NULL,lwd=1, mgcv=T,mgcv.col="blue", mgcv.lty="solid",mgcv.lwd=1, ci=T,scb=T,scb.level=0.95,scb.method="TK", scb.lty="dashed",scb.lwd=1,col="black",ci.lines=c(F,F), ci.lty = c("dotted","dotted"),ci.col=c(grey(0.80),grey(0.85)),meanlevel=T,rug=T,jitter=T,...){
  if (class(object)[2]=="bayesgauss") {equation=1;object$numSplines[[2]]=0}
  if (PLOT) par(ask=ask)
  out=list()
  if (!is.null(equation)) if ((equation==1 & object$numSplines[[1]]==0) |(equation==2 & object$numSplines[[2]]==0)) stop("No nonparametric (univariate) effect in equation ",equation)
  if (!is.null(covariate) & is.null(equation)) stop("If covariate is secified (i.e. !=NULL), equation must be given.")

  if (is.character(covariate)){
    #varying coefficient
    if (length(which(names(object$covariates$by)[(1+ (equation==2)* (object$numSplines[[1]]+object$numSpatial[[1]])):(object$numSplines[[1]]+object$numSpatial[[1]]+ (equation==2)* object$numSplines[[2]])]==covariate))>0)
      number=(equation==2)*(object$numSplines[[1]]+object$numSpatial[[1]])+  which(names(object$covariates$by)[(1+ (equation==2)* (object$numSplines[[1]]+object$numSpatial[[1]])):(object$numSplines[[1]]+ object$numSpatial[[1]]+(equation==2)* object$numSplines[[2]])]==covariate)
    #"regular" coefficient
    else number= (equation==2)*(object$numSplines[[1]]+object$numSpatial[[1]])+ which(names(object$covariates$nonparametric)[(1+ (equation==2)* (object$numSplines[[1]]+object$numSpatial[[1]])):(object$numSplines[[1]]+ object$numSpatial[[1]]+(equation==2)* object$numSplines[[2]])]==covariate)
   }
  else if (is.numeric(covariate)) number=covariate+(equation==2)*(object$numSplines[[1]]+object$numSpatial[[1]])
  else{    #covariate not given
    if (is.null(equation)){   #equation not given
      number=numeric()
      if (object$numSplines[[1]]>0) number=1:object$numSplines[[1]]
      if (object$numSplines[[2]]>0) number=c(number, (object$numSplines[[1]]+object$numSpatial[[1]]+1):(object$numSplines[[1]]+object$numSpatial[[1]]+object$numSplines[[2]]))
    }
    else{        #equation given
      if (equation==1 & object$numSplines[[1]]>0) number=1:object$numSplines[[1]]
      else if (equation==2 & object$numSplines[[2]]>0) number=(object$numSplines[[1]]+object$numSpatial[[1]]+1):(object$numSplines[[1]]+object$numSpatial[[1]]+object$numSplines[[2]])
    }
  }
  
  if (length(number)==0) stop("Specified covariate could not be matched. Probably the specified covariate is not contained in the equation.")

  for(j in number){
    covariate=object$covariates$nonparametric[[j]]
    ord=order(covariate)
    x=covariate[ord]

if (!center){
#if (class(object)[2]=="bayesIV") intercept=object$intercepts[object$eq[j]]  else
intercept=object$coefficients[[object$eq[j]]][1]
}

else intercept=0
    # is varying coefficient?
      if (length(object$f.by[[j]])==1) {
        varying=F
        fitted=object$f[[j]][ord] +intercept
      }
      else {
        varying=T
        fitted=object$f.by[[j]][ord]
      }
 
      if (is.null(ylim) & ci) {ylim1=c(min(object$ci.f[[j]][,1]),max(object$ci.f[[j]][,4])); if (!center) ylim1=ylim1+intercept} else ylim1=ylim
      if (is.null(xlab)) xlab1= paste(names(object$covariates$nonparametric)[j], "  (in equation ",object$eq[j],")",sep="")  else xlab1=xlab
      if (!varying){if (is.null(ylab)) ylab1= paste("s(",names(object$f)[j],")",sep="") else ylab1=ylab }
      if (varying){ if (is.null(ylab)) ylab1= paste("s(",names(object$f.by)[j],"):",names(object$covariates$by)[j],sep="") else ylab1=ylab}#   main=names(object$f)[j]
     #  simultaneous cbs
        if (scb){
          if (length(object$scb)>0){ if (center==object$scb[[j]]$center) scb1=object$scb[[j]] else {scb1=scbB(object, level=scb.level,method=scb.method,select=j,center=center)}}
          else              scb1=scbB(object, level=scb.level,method=scb.method,select=j,center=center)
         out[[j]]=list(covariate=x,fitted=fitted,lower=scb1$lower[ord],upper=scb1$upper[ord],center=scb1$center)
          class(out[[j]])="scbb"
        }
    if (PLOT){
      plot( x,fitted, type="n",xlab=xlab1,ylab=ylab1,ylim=ylim1,main=main,...)

      # plot pointwise cis
        if (ci){
          if (center){
            polygon(c(x, rev(x)), c(object$ci.f[[j]][ord,1], rev(object$ci.f[[j]][ord,4])), col = ci.col[2], border = NA)
            polygon(c(x, rev(x)), c(object$ci.f[[j]][ord,2], rev(object$ci.f[[j]][ord,3])), col = ci.col[1], border = NA)
            if (ci.lines[1]){
              lines(x,object$ci.f[[j]][ord,2],col=col,lwd=lwd,lty=ci.lty[2])   #
              lines(x,object$ci.f[[j]][ord,3],col=col,lwd=lwd,lty=ci.lty[2])   #
            }
            if (ci.lines[2]){
              lines(x,object$ci.f[[j]][ord,1],col=col,lwd=lwd,lty=ci.lty[1])   #
              lines(x,object$ci.f[[j]][ord,4],col=col,lwd=lwd,lty=ci.lty[1])   #
            }
          }
          else{
if (class(object)[2]!="bayesgauss"){       #uncentered PCIs only for DPM currently....
            polygon(c(x, rev(x)), c(object$ci.f.uncentered[[j]][ord,1], rev(object$ci.f.uncentered[[j]][ord,4])), col = ci.col[2], border = NA)
            polygon(c(x, rev(x)), c(object$ci.f.uncentered[[j]][ord,2], rev(object$ci.f.uncentered[[j]][ord,3])), col = ci.col[1], border = NA)
            if (ci.lines[1]){
              lines(x,object$ci.f.uncentered[[j]][ord,2],col=col,lwd=lwd,lty=ci.lty[2])   #
              lines(x,object$ci.f.uncentered[[j]][ord,3],col=col,lwd=lwd,lty=ci.lty[2])   #
            }
            if (ci.lines[2]){
              lines(x,object$ci.f.uncentered[[j]][ord,1],col=col,lwd=lwd,lty=ci.lty[1])   #
              lines(x,object$ci.f.uncentered[[j]][ord,4],col=col,lwd=lwd,lty=ci.lty[1])   #
            }
}
          }
        }
      # plot simultaneous cbs
        if (scb){
          if (length(object$scb)>0){
            if (center==object$scb[[j]]$center) {
              lines(x,scb1$upper,lwd=scb.lwd,lty=scb.lty)
              lines(x,scb1$lower,lwd=scb.lwd,lty=scb.lty)
            }
            else{
              lines(x,scb1$upper[ord],lwd=scb.lwd,lty=scb.lty)
              lines(x,scb1$lower[ord],lwd=scb.lwd,lty=scb.lty)
            }
          }
          else{
            lines(x,scb1$upper[ord],lwd=scb.lwd,lty=scb.lty)
            lines(x,scb1$lower[ord],lwd=scb.lwd,lty=scb.lty)
          }
        }
      abline(0,0,lwd=1)
      # plot mean level of effect in case of a varying coefficient
        if (varying & meanlevel) abline(h=mean(object$f.by[[j]]),lty="dashed",lwd=lwd)
      # plot fitted line
        lines(x,fitted,col=col,lwd=lwd)   #

      # mgcv
        if (varying==F & mgcv & length(object$f.mgcv)>0) lines(x,object$f.mgcv[[j]][ord], col =mgcv.col,lty=mgcv.lty,lwd=mgcv.lwd)

      if (rug){if (jitter) rug(jitter(covariate)) else rug(covariate)  }
    }
  }          
  invisible(out)
}
