############################
# Plot autocorrelation functions for an object returned by function bayesIV
  plotacf=function(object, lag=50, ask=T, pages=1, ...){
    par(ask=ask)
    winsum=dim(object$coefficients.sample[[1]])[2]+max(0,dim(object$coefficients.sample[[2]])[2])+length(object$sigma.random.sample)+(class(object)[2]=="bayesIVgauss")*3
    print(winsum)
    if(all(par()$mfrow==c(1,1)) & pages==1){par(mfrow=c(ceiling(winsum/ceiling(sqrt(winsum))),ceiling(sqrt(winsum))))}

    for (j in 1:dim(object$coefficients.sample[[1]])[2]) acf(object$coefficients.sample[[1]][,j],lag.max=lag[1],  main=names(object$coefficients[[1]])[j],...)
    if (!is.null(dim(object$coefficients.sample[[2]]))) for (j in 1:dim(object$coefficients.sample[[2]])[2]) acf(object$coefficients.sample[[2]][,j],lag.max =lag[1], main=names(object$coefficients[[2]])[j],...)
    if (length(object$sigma.random.sample)>0){
      if(!is.null(object$sigma.random.sample[[1]])) acf(object$sigma.random.sample[[1]],lag.max=lag[1], main="Variance of random intercept, eq.1",...)
      if(!is.null(object$sigma.random.sample[[2]])) acf(object$sigma.random.sample[[2]],lag.max=lag[1], main="Variance of random intercept, eq.2",...)
    }
    if (class(object)[2]=="bayesIVgauss"){
      acf(object$sigma11.sample,lag.max=lag[1], main="Var(eps1)",...)
      acf(object$sigma22.sample,lag.max=lag[1], main="Var(eps2)",...)
      acf(object$sigma12.sample,lag.max=lag[1], main="Cov(eps1,eps2)",...)
    }
  }
