#Auxillary function used for Dirichlet Process mixture. These functions are originally from package bayesm with small changes.

pandterm=function(message) {stop(message,call.=FALSE)}


#get_ytxt=function(y,z,delta,x,w,ncomp,indic,comps){
#  yt=NULL; xt=NULL;
#  if(missing(w)) isw=FALSE else isw=TRUE
#  if(isw) ncolw=ncol(w)
#  for (k in 1:ncomp){
#    nobs=sum(indic==k)
#    if(nobs > 0)    {
#       if(isw) wk=matrix(w[indic==k,],ncol=ncolw)
#       zk=matrix(z[indic==k,],ncol=length(delta))
#       yk=y[indic==k]
#       xk=matrix(x[indic==k],ncol=1)
#       Sigma=backsolve(comps[[k]][[2]],diag(2))
#       Sigma=crossprod(Sigma)
#       mu=comps[[k]][[1]]
#       e1 = as.vector(xk-zk%*%delta)
#       ee2 = mu[2] +(Sigma[1,2]/Sigma[1,1])*(e1-mu[1])
#       sig = sqrt(Sigma[2,2]-(Sigma[1,2]^2/Sigma[1,1]))
#       yt = c(yt,(yk-ee2)/sig)
#       if(isw)       {xt = rbind(xt,(cbind(xk,wk)/sig))}
#       else          {xt=rbind(xt,xk/sig)}
#    }
#  }
#  return(list(xt=xt,yt=yt))
#}
#
#
#get_ytxtd=function(y,z,beta,gamma,x,w,ncomp,indic,comps,dimd){
#yt=NULL; xtd=NULL;
#if(missing(w)) isw=FALSE else isw=TRUE
#if(isw) ncolw=ncol(w)
#C = matrix(c(1,beta,0,1),nrow=2)
#for (k in 1:ncomp)
#   {
#    nobs=sum(indic==k)
#    if(nobs > 0)
#     {
#      xtdk=matrix(nrow=2*nobs,ncol=dimd)
#      ind=seq(1,(2*nobs-1),by=2)
#      if(isw) wk=matrix(w[indic==k,],ncol=ncolw)
#      zk=matrix(z[indic==k,],ncol=dimd)
#      zveck=as.vector(t(zk))
#      yk=y[indic==k]
#      xk=x[indic==k]
#      Sigma=backsolve(comps[[k]][[2]],diag(2))
#      Sigma=crossprod(Sigma)
#      mu=comps[[k]][[1]]
#      B = C%*%Sigma%*%t(C)
#      L = t(chol(B))
#      Li=backsolve(L,diag(2),upper.tri=FALSE)
#      if(isw) {u=as.vector((yk-wk%*%gamma-mu[2]-beta*mu[1]))}
#      else {u=as.vector((yk-mu[2]-beta*mu[1]))}
#      ytk = as.vector(Li %*% rbind((xk-mu[1]),u))
#
#      z2=rbind(zveck,beta*zveck)
#      z2=Li%*%z2
#      zt1=z2[1,]
#      zt2=z2[2,]
#
#      dim(zt1)=c(dimd,nobs)
#      zt1=t(zt1)
#      dim(zt2)=c(dimd,nobs)
#      zt2=t(zt2)
#
#      xtdk[ind,]=zt1
#      xtdk[-ind,]=zt2
#
#      yt=c(yt,ytk)
#      xtd=rbind(xtd,xtdk)
#    }
#    }
#return(list(yt=yt,xtd=xtd))
#}
#


rthetaDP= function(maxuniq,alpha,lambda,Prioralpha,theta,thetaStar,indic,q0v,y,gridsize){
#
#  function to make one draw from DP process
#
#  P. Rossi 1/06
#  added draw of alpha 2/06
#  removed lambdaD,etaD and function arguments 5/06
#  removed thetaStar argument to .Call and creation of newthetaStar 7/06
#  removed q0 computations as eta is not drawn  7/06
#  changed for new version of thetadraw and removed calculation of thetaStar before
#    .Call  7/07
#
#      y(i) ~ f(y|theta[[i]],eta)
#      theta ~ DP(alpha,G(lambda))
#              note: eta is not used
#output:
#   list with components:
#      thetaDraws: list, [[i]] is a list of the ith draw of the n theta's
#                  where n is the length of the input theta and nrow(y)
#      thetaNp1Draws: list, [[i]] is ith draw of theta_{n+1}
#args:
#   maxuniq: the maximum number of unique thetaStar values -- an error will be raised
#            if this is exceeded
#   alpha,lambda: starting values (or fixed DP prior values if not drawn).
#   Prioralpha: list of hyperparms of alpha prior
#   theta: list of starting value for theta's
#   thetaStar: list of unique values of theta, thetaStar[[i]]
#   indic:  n vector of indicator for which unique theta (in thetaStar)
#   y: is a matrix nxk
#         thetaStar: list of unique values of theta, thetaStar[[i]]
#   q0v:a double vector with the same number of rows as y, giving \Int f(y(i)|theta,eta) dG_{lambda}(theta).
#
  #  define needed functions for rthetaDP
  # -----------------------------------------------------------------------------------------------
  pandterm = function(message) stop(message, call. = FALSE)
  # ----------------------------------------------------------------------------------------------
  rmultinomF=function(p) return(sum(runif(1) > cumsum(p))+1)
  # -----------------------------------------------------------------------------------------------
  alphaD=function(Prioralpha,Istar,gridsize){
    #
    #  function to draw alpha using prior, p(alpha)= (1-(alpha-alphamin)/(alphamax-alphamin))**power
    #
    power=Prioralpha$power
    alphamin=Prioralpha$alphamin
    alphamax=Prioralpha$alphamax
    n=Prioralpha$n
    alpha=seq(from=alphamin,to=(alphamax-0.000001),len=gridsize)
    lnprob=Istar*log(alpha) + lgamma(alpha) - lgamma(n+alpha) +
          power*log(1-(alpha-alphamin)/(alphamax-alphamin))
    lnprob=lnprob-median(lnprob)
    probs=exp(lnprob)
    probs=probs/sum(probs)
    return(alpha[rmultinomF(probs)])
  }
  yden=function(thetaStar,y,eta){
    #
    # function to compute f(y | theta)
    # computes f for all values of theta in theta list of lists
    #
    # arguments:
    #   thetaStar is a list of lists.  thetaStar[[i]] is a list with components, mu, rooti
    #   y |theta[[i]] ~ N(mu,(rooti %*% t(rooti))^-1)  rooti is inverse of Chol root of Sigma
    #   eta is not used
    #
    # output:
    #   length(thetaStar) x n array of values of f(y[j,]|thetaStar[[i]]
    #
    nunique=length(thetaStar)
    n=nrow(y)
    ydenmat=matrix(double(n*nunique),ncol=n)
    k=ncol(y)

    for(i in 1:nunique){
       # now compute vectorized version of lndMvn
       # compute y_i'RIRI'y_i for all i
       #
       mu=thetaStar[[i]]$mu; rooti=thetaStar[[i]]$rooti
       quads=colSums((crossprod(rooti,(t(y)-mu)))^2)
       ydenmat[i,]=exp(-(k/2)*log(2*pi) + sum(log(diag(rooti))) - .5*quads)
    }
    return(ydenmat)
  }
  GD=function(lambda){
    #
    # function to draw from prior for Multivariate Normal Model
    #
    # mu|Sigma ~ N(mubar,Sigma x Amu^-1)
    # Sigma ~ IW(nu,V)
    #
    #
    nu=lambda$nu
    V=lambda$V
    mubar=lambda$mubar
    Amu=lambda$Amu
    k=length(mubar)
    Sigma=rwishart(nu,chol2inv(chol(lambda$V)))$IW
    root=chol(Sigma)
    mu=mubar+(1/sqrt(Amu))*t(root)%*%matrix(rnorm(k),ncol=1)
    return(list(mu=as.vector(mu),rooti=backsolve(root,diag(k))))
  }
  thetaD=function(y,lambda,eta){
    #
    # function to draw from posterior of theta given data y and base prior G0(lambda)
    #
    # here y ~ N(mu,Sigma)
    # theta = list(mu=mu,rooti=chol(Sigma)^-1)
    # mu|Sigma ~ N(mubar,Sigma (x) Amu-1)
    # Sigma ~ IW(nu,V)
    #
    # arguments:
    #   y is n x k matrix of obs
    #   lambda is list(mubar,Amu,nu,V)
    #   eta is not used
    # output:
    #   one draw of theta, list(mu,rooti)
    #        Sigma=inv(rooti)%*%t(inv(rooti))
    #
    # note: we assume that y is a matrix. if there is only one obs, y is a 1 x k matrix
    #
    rout=rmultireg(y,matrix(c(rep(1,nrow(y))),ncol=1),matrix(lambda$mubar,nrow=1),matrix(lambda$Amu,ncol=1),
           lambda$nu,lambda$V)
    return(list(mu=as.vector(rout$B),rooti=backsolve(chol(rout$Sigma),diag(ncol(y)))))
  }
  #
  #  END OF REQUIRED FUNCTIONS AREA
  # --------------------------------------------------------------------------------------------

   n = length(theta)

   eta=NULL    # note eta is not used
   thetaNp1=NULL

   p=c(rep(1/(alpha+(n-1)),n-1),alpha/(alpha+(n-1)))

   nunique=length(thetaStar)

   if(nunique > maxuniq ) { pandterm("maximum number of unique thetas exceeded")}
   ydenmat=matrix(double(maxuniq*n),ncol=n)
   ydenmat[1:nunique,]=yden(thetaStar,y,eta)
   #  ydenmat is a length(thetaStar) x n array of density values given f(y[j,] | thetaStar[[i]]
   #  note: due to remix step (below) we must recompute ydenmat each time!

   # use .Call to draw theta list
   out= .Call("thetadraw",y,ydenmat,indic,q0v,p,theta,lambda,eta=eta,
                  thetaD=thetaD,yden=yden,maxuniq,nunique,new.env(),PACKAGE="bayesm")

   # theta has been modified by thetadraw so we need to recreate thetaStar
   thetaStar=unique(theta)
   nunique=length(thetaStar)

   #thetaNp1 and remix
   probs=double(nunique+1)
   indlist = lapply(thetaStar,function(x) which(sapply(theta,identical,x)))
  #probs=sapply(indlist, function(x) length(x)/(alpha+n))
  #new_utheta=lapply(indlist, function(x) thetaD(y[x,,drop=FALSE],lambda,eta) )
   for(j in 1:nunique) {
   ind=indlist[[j]]
       probs[j]=length(ind)/(alpha+n)
       new_utheta=thetaD(y[ind,,drop=FALSE],lambda,eta)
       for(i in seq_along(ind)) {theta[[ind[i]]]=new_utheta}
       indic[ind]=j
       thetaStar[[j]]=new_utheta
   }
   probs[nunique+1]=alpha/(alpha+n)
   ind=rmultinomF(probs)
   if(ind==length(probs)) {
      thetaNp1=GD(lambda)
   } else {
      thetaNp1=thetaStar[[ind]]
   }

   #alpha
   alpha=alphaD(Prioralpha,nunique,gridsize)

   return(list(theta=theta,indic=indic,thetaStar=thetaStar,
               thetaNp1=thetaNp1,alpha=alpha,Istar=nunique))
}


#
# -----------------------------------------------------------------------------------------


q0=function(y,lambda,eta){
#
# function to compute a vector of int f(y[i]|theta) p(theta|lambda)dlambda
#     here p(theta|lambda) is G0 the base prior
#
# implemented for a multivariate normal data density and standard conjugate
# prior:
#    theta=list(mu,Sigma)
#    f(y|theta) is N(mu,Sigma)
#    lambda=list(mubar,Amu,nu,V)
#       mu|Sigma ~ N(mubar,Sigma (x) Amu^-1)
#       Sigma ~ IW(nu,V)
#
# arguments:
#    Y is n x k matrix of observations
#    eta is not used
#    lambda=list(mubar,Amu,nu,V)
#
# output:
#    vector of q0 values for each obs (row of Y)
#
# p. rossi 12/05
#
# here y is matrix of observations (each row is an obs)

mubar=lambda$mubar; nu=lambda$nu ; Amu=lambda$Amu; V=lambda$V
k=ncol(y)
R=chol(V)
logdetR=sum(log(diag(R)))
if (k > 1)
  {lnk1k2=(k/2)*log(2)+log((nu-k)/2)+lgamma((nu-k)/2)-lgamma(nu/2)+sum(log(nu/2-(1:(k-1))/2))}
else
  {lnk1k2=(k/2)*log(2)+log((nu-k)/2)+lgamma((nu-k)/2)-lgamma(nu/2)}
constant=-(k/2)*log(2*pi)+(k/2)*log(Amu/(1+Amu)) + lnk1k2 + nu*logdetR
#
# note: here we are using the fact that |V + S_i | = |R|^2 (1 + v_i'v_i)
#       where v_i = sqrt(Amu/(1+Amu))*t(R^-1)*(y_i-mubar), R is chol(V)
#
#       and S_i = Amu/(1+Amu) * (y_i-mubar)(y_i-mubar)'
#
mat=sqrt(Amu/(1+Amu))*t(backsolve(R,diag(ncol(y))))%*%(t(y)-mubar)
vivi=colSums(mat^2)

lnq0v=constant-((nu+1)/2)*(2*logdetR+log(1+vivi))

return(exp(lnq0v))
}
