#function copied from package bayesm. Only PACKAGE="bayesm" added to .Call

rthetaDPbayesIV=function (maxuniq, alpha, lambda, Prioralpha, theta, thetaStar, 
          indic, q0v, y, gridsize) 
{
  pandterm = function(message) stop(message, call. = FALSE)
  rmultinomF = function(p) return(sum(runif(1) > cumsum(p)) + 
                                    1)
  alphaD = function(Prioralpha, Istar, gridsize) {
    power = Prioralpha$power
    alphamin = Prioralpha$alphamin
    alphamax = Prioralpha$alphamax
    n = Prioralpha$n
    alpha = seq(from = alphamin, to = (alphamax - 1e-06), 
                len = gridsize)
    lnprob = Istar * log(alpha) + lgamma(alpha) - lgamma(n + 
                                                           alpha) + power * log(1 - (alpha - alphamin)/(alphamax - 
                                                                                                          alphamin))
    lnprob = lnprob - median(lnprob)
    probs = exp(lnprob)
    probs = probs/sum(probs)
    return(alpha[rmultinomF(probs)])
  }
  yden = function(thetaStar, y, eta) {
    nunique = length(thetaStar)
    n = nrow(y)
    ydenmat = matrix(double(n * nunique), ncol = n)
    k = ncol(y)
    for (i in 1:nunique) {
      mu = thetaStar[[i]]$mu
      rooti = thetaStar[[i]]$rooti
      quads = colSums((crossprod(rooti, (t(y) - mu)))^2)
      ydenmat[i, ] = exp(-(k/2) * log(2 * pi) + sum(log(diag(rooti))) - 
                           0.5 * quads)
    }
    return(ydenmat)
  }
  GD = function(lambda) {
    nu = lambda$nu
    V = lambda$V
    mubar = lambda$mubar
    Amu = lambda$Amu
    k = length(mubar)
    Sigma = rwishart(nu, chol2inv(chol(lambda$V)))$IW
    root = chol(Sigma)
    mu = mubar + (1/sqrt(Amu)) * t(root) %*% matrix(rnorm(k), 
                                                    ncol = 1)
    return(list(mu = as.vector(mu), rooti = backsolve(root, 
                                                      diag(k))))
  }
  thetaD = function(y, lambda, eta) {
    rout = rmultireg(y, matrix(c(rep(1, nrow(y))), ncol = 1), 
                     matrix(lambda$mubar, nrow = 1), matrix(lambda$Amu, 
                                                            ncol = 1), lambda$nu, lambda$V)
    return(list(mu = as.vector(rout$B), rooti = backsolve(chol(rout$Sigma), 
                                                          diag(ncol(y)))))
  }
  n = length(theta)
  eta = NULL
  thetaNp1 = NULL
  p = c(rep(1/(alpha + (n - 1)), n - 1), alpha/(alpha + (n - 
                                                           1)))
  nunique = length(thetaStar)
  if (nunique > maxuniq) {
    pandterm("maximum number of unique thetas exceeded")
  }
  ydenmat = matrix(double(maxuniq * n), ncol = n)
  ydenmat[1:nunique, ] = yden(thetaStar, y, eta)
  out = .Call("thetadraw", y, ydenmat, indic, q0v, p, theta, 
              lambda, eta = eta, thetaD = thetaD, yden = yden, maxuniq, 
              nunique, new.env(),PACKAGE="bayesm")
  thetaStar = unique(theta)
  nunique = length(thetaStar)
  probs = double(nunique + 1)
  indlist = lapply(thetaStar, function(x) which(sapply(theta, 
                                                       identical, x)))
  for (j in 1:nunique) {
    ind = indlist[[j]]
    probs[j] = length(ind)/(alpha + n)
    new_utheta = thetaD(y[ind, , drop = FALSE], lambda, 
                        eta)
    for (i in seq_along(ind)) {
      theta[[ind[i]]] = new_utheta
    }
    indic[ind] = j
    thetaStar[[j]] = new_utheta
  }
  probs[nunique + 1] = alpha/(alpha + n)
  ind = rmultinomF(probs)
  if (ind == length(probs)) {
    thetaNp1 = GD(lambda)
  }
  else {
    thetaNp1 = thetaStar[[ind]]
  }
  alpha = alphaD(Prioralpha, nunique, gridsize)
  return(list(theta = theta, indic = indic, thetaStar = thetaStar, 
              thetaNp1 = thetaNp1, alpha = alpha, Istar = nunique))
}
