\name{bayesIV-package}
\alias{bayesIV-package}
\docType{package}
\title{
Package for fitting Bayesian Semiparametric Instrumental Variable Regression Models with possibly Non-Normal Errors
}
\description{
Fits geoadditive sample selection models and semiparametric instrumental variable models that allow to correct for endogeneity bias. Covariate effects are allowed to enter with unknown functional form.
Bias correction relies on simultaneous equations specifications with either flexible modeling of the joint error distribution or assuming bivariate normality.
Equations are specified based on geoadditive predictors comprising penalised splines
for nonlinear effects of continuous covariates, Gaussian Markov random fields for spatial effects, and possibly a Dirichlet process prior to
deal with flexible estimation of the distribution of the error terms. Inference is fully Bayesian, employing efficient
Markov Chain Monte Carlo simulation techniques. The resulting posterior samples allow the construction of simultaneous credible bands for the nonparametric effects.
}
\details{

Index:
\preformatted{
am                      Fitting Bayesian Geoadditive Models
bayesIV                 Fitting Bayesian Semiparametric Instrumental
                        Variable Regression models
ssm                     Fitting Bayesian Geoadditive Sample Selection Models

bayesIV-package         Package for fitting Bayesian Semiparametric
                        Instrumental Variable
bayesIVgauss            Fitting Bayesian Semiparametric Instrumental
                        Variable Regression models
density.bayesIV         Plot normal mixture marginal and bivariate
                        densities
plot.bayesIV            Plot nonparametric effects
plot.scbb               Plot nonparametric effects
plotacf                 Plot ACFs of posterior samples of estimated
                        parameters
plotmaps                Plot spatial effects
plotpaths               Plot sampling paths of posterior samples
plotpost                Plot posterior distributions
scbB                    Compute simultaneous credible bands
summary.bayesIV         Summary
}
}
\author{
Manuel Wiesenfarth <m.wiesenfarth@dkfz.de>
}
\references{
}
\seealso{
\code{\link[bayesm]{rivDP}} in package \code{bayesm}; \code{\link{BayesX}} for description of spatial effects related functions.
}
\examples{
#see bayesIV()
}
