\name{density.bayesIV}
\alias{density.bayesIV}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Plot marginal and bivariate error densities
}
\description{
Plot normal mixture marginal and bivariate error densities for objects created with \code{bayesIV()}.
}
\usage{
density(object, marginal=TRUE, contour=TRUE, persp=TRUE,
color=TRUE, contour.col=terrain.colors(100), persp.col="green3",
theta = -30, phi = 15, ltheta = 120, expand=0.9, shade = 0.75, border = NULL,
box = FALSE, nlevels= 10, nstd=2, ngrid=50, ndraw, tol=0.001, ask=TRUE,...)
}
\arguments{
  \item{object}{a bayesIV object produced by \code{\link{bayesIV}}}
%  \item{names}{optional character vector of names for each of the dimensions}
%  \item{Data}{optional matrix of data points, used to paint histograms on marginals and for grid}

  \item{marginal}{logical, if TRUE display marginals densities, default: TRUE}
  \item{contour}{logical, if TRUE display bivariate density as contour plot (calling \code{\link{image}} and \code{\link{contour}}), def: TRUE}
  \item{persp}{logical, if TRUE display bivariate density as perspective plot of surfaces (calling \code{\link{persp}}), def: TRUE}
%  \item{marg.col}{the color for filling the marginal densities}
  \item{contour.col}{a list of colors such as that generated by \code{\link{rainbow}}, \code{\link{heat.colors}}, \code{\link{topo.colors}}, \code{\link{terrain.colors}} or similar functions to be passed to \code{\link{image}} for bivariate density}
  \item{persp.col}{color for perspective plot}

%  \item{par}{if "ask" the user is asked for input, before a new figure is drawn. If it is a vector of length two, the vector is passed to \code{par(mfrow)}, otherwise graphics settings are left as they are}
%\item{mfrow}{}
\item{tol}{Sets xlims such that on the left and right only densities larger than \code{tol} are within the plotted interval. Only for bayesIV objects created using \code{density.method="jara"}.}
  \item{nstd}{number of standard deviations for default Grid (default: 2). Only for bayesIV objects created using \code{density.method="conley"}.}
  \item{ngrid}{number of grid points for density estimates (default: 50). Only for bayesIV objects created using \code{density.method="conley"}.}
  \item{ndraw}{number of draws to average MCMC estimates over (default: all draws available). Can slow down plotting, reduce to obtain faster but less precise plots. Only for bayesIV objects created using \code{density.method="conley"}.}
  \item{Grid}{optional matrix of grid points for densities, default: mean +/- nstd std deviations (if Data not supplied), range of Data if supplied. Only for bayesIV objects created using \code{density.method="conley"}.}
  \item{\dots}{graphical parameters to be passed to plot functions (e.g. \code{nlevels} for the number of contour levels desired in \code{\link{contour}}; theta, phi, ltheta, shade, border and box to be passed to \code{\link{persp}}}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

\seealso{
\code{\link{plot.bayesm.nmix}} in package \code{bayesm}
}
\examples{
#see bayesIV()
}