\name{plotmaps}
\alias{plotmaps}
\title{Plot spatial effects}

\description{
Plots spatial effects of a bayesIV object using function \code{\link[BayesX]{drawmap}} of package BayesX.}

\usage{
plotmaps(object,equation=2, map,pcat=T,ask=T,pages=1,...)
}

\arguments{
  \item{object}{a \code{bayesIV} object}
  \item{equation}{either 1 for first or 2 for second equation}
  \item{map}{map object containing the required boundary information (as obtained by a call to \code{\link[BayesX]{read.bnd}} of package BayesX)}
  \item{ask}{if TRUE (and the R session is interactive) the user is asked for input, before a new figure is drawn.}
  \item{pages}{the number of pages over which to spread the output.
   For example, if \code{pages=1} then all terms will be plotted on one page with the layout performed automatically.
   Does only apply when \code{par()$mfrow==c(1,1)}, i.e. if no layout is specified beforehand.}
  \item{pcat}{option for the visualisation of posterior probabilities (80\% and 95\%).
   In this case, a three-colour scheme representing significantly positive, insignificant and significantly negative values. See \code{\link[BayesX]{drawmap}}}
  \item{\dots}{arguments to be passed to \code{\link[BayesX]{drawmap}} of package BayesX}
 }

\author{Manuel Wiesenfarth}
\references{
%Wiesenfarth, M. and Kneib, T. Bayesian Geoadditive Sample Selection Models...
}
\seealso{
\code{\link[BayesX]{drawmap}} in package BayesX
%% ~~objects to See Also as \code{\link{help}}, ~~~
%package \code{sampleSelection} for frequentist sample selection models, package \code{BayesX} for description of spatial effects related functions.
}

\examples{
#see bayesIV()
}